
#
# Code example demonstrating list comprehensions
#
# author: David Mathias
#

from random import randint

print()

# create list of lists of data elements for use in example
print('Create the data:')
print()

data = []
for i in range(6):
    r = randint(4, 10)
    sublist = [randint(1, 100) for _ in range(r)]
    data.append(sublist)
    if i == 4:
        data.append([])
    
print('data: {}'.format(data))

# create list of minimum values from each list in data
print('This comprehension attempts to create a list of the minimum values')
print('from the lists in data:')
print()

#mins = [min(L) for L in data]


# the first version didn't work because one of the lists 
# in data is empty we can fix that using a filter
print('This time we check to see if each list in data is empty')
print('before trying to get the min:')
print()

mins = [min(L) for L in data if len(L) > 0]

print('mins: {}'.format(mins))
print()
