
#
# Code example demonstrating list comprehensions
#
# author: David Mathias
#

from random import randint

print()

# create list of lists of data elements for use in example
print('Create the data:')
print()

data = []
for i in range(6):
    r = randint(4, 10)
    sublist = [randint(-100, 100) for _ in range(r)]
    data.append(sublist)
    if i == 4:
        data.append([])
    
print('data: {}'.format(data))

# create a single list of all data values from the list data
print('This comprehension creates a list of all data values in list data:')
print()

all_data = [x for L in data for  x in L]

print('all_data: {}'.format(all_data))
print()


# now we want to create the same single list but exclude negatives
print('This time we exclude negative values from the single list:')
print()

all_data = [x for L in data for x in L if x >= 0]

print('all_data: {}'.format(all_data))
print()
